## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm 1.9.0
%bcond_without check
# storj backend has fragile dependencies
%bcond_with storj
# protondrive backend introduces many new deps
%bcond_with protondrive

# https://github.com/rclone/rclone
%global goipath         github.com/rclone/rclone
Version:                1.64.2

%gometa -f

%global goname rclone

%global common_description %{expand:
Rclone is a command line program to sync files and directories to and
from various cloud services.}

# This package uses gold. Tell package-notes implementation about this.
%global _package_note_linker gold

Name:           %{goname}
Release:        %autorelease
Summary:        Rsync for cloud storage

License:        MIT AND BSD-3-Clause
URL:            %{gourl}
Source:         %{gosource}

%description %{common_description}

%prep
%goprep
sed -i "s|github.com/putdotio/go-putio/putio|github.com/putdotio/go-putio|" $(find . -name "*.go")

%if %{without storj}
sed  '/storj/d' -i backend/all/all.go
rm -rf backend/storj
%endif
%if %{without protondrive}
sed  '/protondrive/d' -i backend/all/all.go
rm -rf backend/protondrive
%endif

%generate_buildrequires
%go_generate_buildrequires

%build
export LDFLAGS="-X github.com/rclone/rclone/fs.Version=%{version}"
%gobuild -o %{gobuilddir}/bin/rclone %{goipath}

%{gobuilddir}/bin/%{name} completion bash - > %{name}.bash
%{gobuilddir}/bin/%{name} completion fish - > %{name}.fish
%{gobuilddir}/bin/%{name} completion zsh  - > %{name}.zsh


%install
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
install -Dpm 0644 ./rclone.1 %{buildroot}%{_mandir}/man1/rclone.1

install -Dpm 0644 %{name}.bash %{buildroot}%{bash_completions_dir}/%{name}
install -Dpm 0644 %{name}.fish %{buildroot}%{fish_completions_dir}/%{name}.fish
install -Dpm 0644 %{name}.zsh  %{buildroot}%{zsh_completions_dir}/_%{name}

# https://rclone.org/commands/rclone_mount/#rclone-as-unix-mount-helper
install -m 0755 -vd                     %{buildroot}%{_sbindir}
ln -rs %{buildroot}%{_bindir}/rclone %{buildroot}%{_sbindir}/mount.rclone
ln -rs %{buildroot}%{_bindir}/rclone %{buildroot}%{_bindir}/rclonefs

%if %{with check}
%check
for test in "TestMixed" "TestMetadata" "TestMediaReceiverRegistrarService" \
"TestAccountWriteToWithBuffer" "TestLocal" "TestRemoteGzip" "TestIntegration" \
"TestPolicy3" "TestPolicy2" "TestRcatMetadata" "TestRcatSizeMetadata" \
; do
awk -i inplace '/^func.*'"$test"'\(/ { print; print "\tt.Skip(\"disabled failing test\")"; next}1' $(grep -rl $test)
done
# Skip checks requiring docker or fuse
%gocheck -d backend/crypt \
         -d backend/ftp \
         -d backend/hdfs \
         -d backend/seafile \
         -d backend/sftp \
         -d backend/sia \
         -d backend/swift \
         -d backend/union \
         -d backend/webdav \
         -d cmd/mount \
         -d cmd/mount2 \
         -d cmd/selfupdate \
         -d cmd/serve/docker \
         -d fs/rc/webgui
%endif

%files
%license COPYING
%doc MAINTAINERS.md MANUAL.html RELEASE.md CONTRIBUTING.md MANUAL.md README.md
%doc docs/
%{_bindir}/rclone
%{_bindir}/rclonefs
%{_sbindir}/mount.rclone
%{_mandir}/man1/rclone.1*
%{bash_completions_dir}/%{name}
%{fish_completions_dir}/%{name}.fish
%{zsh_completions_dir}/_%{name}

%changelog
* Fri Oct 20 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> - 1.64.2-1
- Update to 1.64.2 - Closes rhbz#2244697

* Sun Oct 15 2023 Jonathan Steffan <jsteffan@fedoraproject.org> - 1.64.0-2
- Add mount.rclone for systemd.mount support
- Create symlink for utilization in systemd units
- Create optional rclonefs symlink, per documentation

* Thu Oct 12 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> - 1.64.0-1
- Update to 1.64.0 - Closes rhbz#2238581 rhbz#2229610 rhbz#2229606

* Mon Jul 31 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> - 1.63.1-1
- Update to 1.63.1 - Closes rhbz#2155701 rhbz#2163286 rhbz#2171700
  rhbz#2178480 rhbz#2226392
- Don't build storj backend by default
- Use shell completion macros

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.60.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.60.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Nov 23 2022 Mikel Olasagasti Uranga <mikel@olasagasti.info> - 1.60.1-1
- Update to 1.60.1 - Closes rhbz#2144108

* Mon Nov 07 2022 Mikel Olasagasti Uranga <mikel@olasagasti.info> - 1.60.0-1
- Update to 1.60.0

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.57.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 19 2022 Maxwell G <gotmax@e.email> - 1.57.0-6
- Rebuild for
  CVE-2022-{1705,32148,30631,30633,28131,30635,30632,30630,1962} in golang

* Sat Jun 18 2022 Robert-André Mauchin <zebob.m@gmail.com> - 1.57.0-4
- Rebuilt for CVE-2022-1996, CVE-2022-24675, CVE-2022-28327,
  CVE-2022-27191, CVE-2022-29526, CVE-2022-30629

* Sat Feb 19 2022 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 1.57.0-3
- Disable package notes because gold linker is used

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.57.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Dec 21 2021 Robert-André Mauchin <zebob.m@gmail.com> - 1.57.0-1
- Update to commit 1.57.0 Close: rhbz#1953788

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.55.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon May 17 15:41:30 CEST 2021 Robert-André Mauchin <zebob.m@gmail.com> - 1.55.1-1
- Update to 1.55.1

* Wed Apr  7 21:23:12 CEST 2021 Robert-André Mauchin <zebob.m@gmail.com> - 1.55.0-1
- Update to 1.55.0
- Close: rhbz#1936764

* Sat Mar  6 08:41:07 CET 2021 Robert-André Mauchin <zebob.m@gmail.com> - 1.54.0-1
- Update to 1.54.0
- Close: rhbz#1918543

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.53.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Dec 06 00:39:23 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 1.53.3-1
- Update to 1.53.3
- Close: rhbz#1899641
- Fix: rhbz#1900705
- Fix: rhbz#1900719

* Sun Nov 08 14:15:33 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 1.53.2-1
- Update to 1.53.2 (#1840915)

* Fri Sep 18 11:05:08 CEST 2020 Robert-André Mauchin <zebob.m@gmail.com> - 1.53.1-1
- Update to 1.53.1

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.51.0-3
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.51.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Feb 26 23:53:19 CET 2020 Robert-André Mauchin <zebob.m@gmail.com> - 1.51.0-1
- Update to 1.51.0

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.50.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Dec 23 22:22:16 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 1.50.2-1
- Release 1.50.2 (#1756764)

* Sat Sep 28 13:00:14 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 1.49.3-1
- Release 1.49.3 (#1747050)

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.48.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Jun 16 16:26:43 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 1.48.0-1
- Release 1.48.0 (#1720839)

* Sat Apr 13 18:34:07 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 1.47.0-1
- Release 1.47.0 (#1674166)

* Sat Apr 06 21:17:09 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 1.46.0-1
- Release 1.46.0

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.45-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Tue Dec 18 2018 Robert-André Mauchin <zebob.m@gmail.com> - 1.45-1
- Update to version 1.45

* Mon Oct 22 2018 Robert-André Mauchin <zebob.m@gmail.com> - 1.44-1
- Update to version 1.44

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.42-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Jun 28 2018 Robert-André Mauchin <zebob.m@gmail.com> - 1.42-1
- Update to version 1.42

* Tue Mar 20 2018 Robert-André Mauchin <zebob.m@gmail.com> - 1.41-1
- Update to version 1.41
- Use new Go packaging

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.39-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Dec 24 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.39-1
- Update to version 1.39

* Sun Oct 01 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.38-1
- Update to version 1.38

* Fri Jul 28 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.37-2
- Unbundled revision

* Sun Jul 23 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.37-1
- Update to version 1.37

* Thu Jul 20 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.36-2
- Update to Fedora Packaging Guidelines specification

* Sat Mar 25 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.36-1
- Update to version 1.36

* Fri Jan 06 2017 Robert-André Mauchin <zebob.m@gmail.com> - 1.35-1
- Update to version 1.35

* Sun Dec 11 2016 Robert-André Mauchin <zebob.m@gmail.com> - 1.34-1
- Initial RPM release


